/* alias.c -- Builtin alias. */

/* Copyright (C) 2003 Mike Thielman 
 *
 * This file is part of pr0nsh, the Porn Shell.
 *
 * Pr0nsh is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2, or (at your option) any later
 * version.
 *
 * Pr0nsh is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with Pr0nsh; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place, Suite 330, Boston, MA 02111 USA. */

#include <stdio.h>
#include <string.h>

#include "pr0nsh.h"
#include "shell/alias.h"
#include "util/llist.h"
#include "shell/shell.h"

int _builtin_alias(LinkedList *args)
{
  LinkedList *cur = args;
  char *p;
  Alias *curalias;
  char *alias,*cmd;

  if(numEntriesll(args) == 0) {
    curalias=getCurrentAliases();
    while(curalias != NULL)
    {
      outputout("alias %s='%s'\n", curalias->cmd, curalias->alias);
      curalias = curalias->next;
    }
  }
  else {
    while(cur) {
      p = strchr(cur->s,'=');
      if(p) {
        if(*(p+1) == 0) { // If this arg is foo= then next arg is value
          alias = strdup(cur->s);
          alias[strlen(alias)-1] = 0;
          cur = cur->next;
          if(cur) {
            _makeAlias(alias,cur->s);
          } else {
            outputerr("Invalid number of arguments, alias");
            outputerr(" %s not set\n", alias);
            return RET_ERROR;
          } 
        } else {          // If we get here we have foo=bar
          alias = strdup(p+1);
          cmd = strdup(cur->s);
          p = strchr(cmd,'=');
          *p = 0;
          _makeAlias(cmd,alias);
        }
      }
      else {
        if((curalias = LookupAlias(cur->s)) != NULL) {
           outputout("alias %s='%s'\n", cur->s, curalias->alias);
        }
        else {
          outputerr("  alias: %s: not defined.\n", cur->s);
        }
      }
      cur=cur->next;
    }
  }
  return RET_SUCCESS;
} 
