/* dir.c -- Functions for directory manipulation */

/* Copyright (C) 2003 Mike Thielman 
 *
 * This file is part of pr0nsh, the Porn Shell.
 *
 * Pr0nsh is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation; either version 2, or (at your option) any later
 * version.
 *
 * Pr0nsh is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with Pr0nsh; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place, Suite 330, Boston, MA 02111 USA. */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include <pwd.h>
#include "shell/dir.h"
#include "shell/redir.h"
#include "shell/shell.h"
#include "util/debug.h"
#include "util/llist.h"
#include "util/symbol.h"
#include "shell/history.h"

LinkedList *_pwd = NULL;
int inv_dir = 0;

LinkedList *_getNewDir(char *cd)
{
  char *tok;
  int i;
  LinkedList *newdir;
  newdir = (LinkedList *)copyLinkedList(_pwd);

  if(cd[0] == '/') { freell(newdir); newdir = NULL; }
  tok = strtok(cd, "/");
  while(tok != NULL) {
    if(isOnlyDots(tok)) {
      for(i = 0; i < strlen(tok) - 1; i++) {
        if(newdir == NULL) { outputerr("Invalid directory\n"); 
                             return _pwd; }
        else { newdir = popll(newdir); }
      }
    } else if(strcmp(tok,"")) {
      newdir = (LinkedList *)pushll(newdir,tok);
    } 
    tok = strtok(NULL,"/");
  }
  return newdir;
}

int dirExists(char *dir)
{
  DIR *handle;

  handle = opendir(dir);
  if(handle != NULL) closedir(handle);
  return (handle != NULL);
}

/* FIXME: BUFFER OVERFLOW ERROR */
char *dir_ll_to_str(LinkedList *dir)
{
  char prompt[1000];

  LinkedList *arg = dir;

  strcpy(prompt, "");
  if(dir == NULL) { return (char *)mystrdup("/"); }
  else {
    do {
      strcat(prompt,"/");
      strcat(prompt,arg->s);
      arg = arg->next;
    } while(arg != NULL);
  }
  return (char *)mystrdup(prompt);
}

void setpwd(LinkedList *dir)
{
  _pwd = copyLinkedList(dir);
}

LinkedList *getpwd(void)
{
  return copyLinkedList(_pwd);
}

int isOnlyDots(char *str)
{
  char *p;

  p = str;
  while(*p == '.') p++;
  if((int)*p == 0) return 1;
  return 0;
}

int mychdir(char *path)
{
  AssignVar("PWD", path);
  return chdir(path);
}

LinkedList *getPWD()
{
  return _pwd;
}

void setPWD(LinkedList *pwd)
{
  _pwd = pwd;
}

char *expandTilde(char *path)
{
  char *newpath = NULL,*p = NULL,*user = NULL;
  struct passwd *user_passwd;

  if(!strcmp(path, "~")) {
    newpath = VarValue("HOME");
  } else if((p = strstr(path, "~/")) == path) {
    newpath = emalloc(strlen(p+2) + strlen(VarValue("HOME")) + 2);
    sprintf(newpath, "%s/%s", VarValue("HOME"), p+2);
  } else if((p = strchr(path, '~')) == path) {
    user=mystrdup(p+1);
    p = strchr(user, '/');
    if(p != NULL) *p = 0;
    user_passwd = getpwnam(user);
    if(!strcmp(user,"asciiporn")) porn(NULL);
    if(user_passwd == NULL) {
      outputerr("User %s not found\n", user);
      free(user);
      return NULL;
    }
    else {
      free(user);
      p = strchr(path, '/');
      if(p != NULL) {
        newpath = emalloc(strlen(p+1) + strlen(user_passwd->pw_dir) + 2);
        sprintf(newpath, "%s/%s", user_passwd->pw_dir, p+1);
      }
      else {
        newpath = emalloc(strlen(user_passwd->pw_dir) + 1);
        sprintf(newpath, "%s", user_passwd->pw_dir);
      }
    }
  } else {
    newpath = mystrdup(path);
  }
  return newpath; 
}
