#ifndef _REDIR_H
#define _REDIR_H

typedef struct REDIR {
  int stream;     /* ie 0 - stdin, 1 - stdout, 2 - stderr, etc */
  char *filename;
  int type;
  int fd;
  int fdclose0;
  int fdclose1;
  struct REDIR *next;
} REDIR;

typedef struct BUILTIN_REDIR {
  int in;
  int out;
  int err;
} BUILTIN_REDIR;

/* Possible values for type field of REDIR struct */
#define REDIR_OUTPUT 1
#define REDIR_OUTPUT_APPEND 2
#define REDIR_INPUT 3

#define PIPE_NONE -1

#define STREAM_STDIN 0
#define STREAM_STDOUT 1
#define STREAM_STDERR 2

int getSTDOUTfd();
int getSTDINfd();
int getSTDERRfd();
void setSTDOUTfd(int fd);
void setSTDINfd(int fd);
void setSTDERRfd(int fd);

void freeREDIR(REDIR *redir);
REDIR *copyREDIR(REDIR *redir);
REDIR *newREDIR(void);

#endif
